::Batch file created by Vashypooh, Modified by awidawad
::KF Utility V 0.9.9
::You are free to tweak or modify this as you see fit,
::Just please be respectful is all I ask.

::Initial work by ubeezee & yareally
::Full revert based off method from Clavin, "tweaked" by Vashypooh
::Full credit of TWRP goes to Team Win for releasing an awesome tool! Good job guys
::Visit TeamWin @ http://teamw.in/

::Set our Window Title
@title Kindle Fire Utility 0.9.9

::Set our default parameters
@echo off
cls
color 1b

::Here is my solution to allowing publishing files without a new release in emergencies. Added new mantained site 3/11/2013 -awidawad 
echo. Obtaining latest file list..
echo.
start /MIN tools\wget -O files\files.log "http://pastebin.com/raw.php?i=FQCx40fF"

::We should kill ADB and restart it at launch.
echo. Resetting ADB and Launching KF Utility...
tools\adb kill-server
tools\adb start-server

::Establish variables
set tmp=""

::Establish variables that we import
set updatemd5=
set updateurl=
set update1md5=
set update1url=
set twrpmd5=
set twrpurl=
set appsmd5=
set appsurl=
set fffmd5=
set fffurl=
set fffeurl=
set fffemd5=
set cotrurl=
set cotrmd5=
set md5check=


::Variables for determining device status.
set adb="Unknown"
set fastboot="Unknown"
set adbcomp="List of devices attached"
set fbcomp=""
set mode=""
set installed=""

:menuLOOP
	::Lets check our current device status
	call:check_status
	
	::Print our header
	call:header
	
	::Load up our menu selections
	for /f "tokens=1,2,* delims=_ " %%A in ('"findstr /b /c:":menu_" "%~f0""') do echo.  %%B  %%C
	
	call:printstatus

	set choice=
	echo.&set /p choice=Please make a selection or hit ENTER to exit: ||GOTO:EOF
	echo.&call:menu_%choice%
GOTO:menuLOOP

:menu_1    Bootmode Menu
	::Lets check our current device status
	call:check_status
	
	::Print our header
	call:header
	
	for /f "tokens=1,2,* delims=_ " %%A in ('"findstr /b /c:":bootsubmenu_" "%~f0""') do echo.  %%B  %%C
	
	call:printstatus
	
	set choice=
	echo.&set /p choice=Please make a selection or hit ENTER to return: ||GOTO:EOF
	echo.&call:bootsubmenu_%choice%
GOTO:menu_1

:menu_2    Install Permanent Root with Superuser
	::Lets check our current device status
	cls
	call:check_status
	
	::Begin the rooting process. > This should work with update 6.3.2 -awidawad
	call:rootkindle
	
	::Pause to show our output
	pause
GOTO:EOF

:menu_3    Install Latest TWRP Recovery
	call:install_twrp
GOTO:EOF

:menu_4    Install latest COTR Recovery
	call:install_cotr
GOTO:EOF

:menu_5    Install Latest FireFireFire
	call:install_fff
GOTO:EOF

:menu_6    Extras (Requires Root)
	::Lets check our current device status
	call:check_status
	
	::Print our header
	call:header
	
	for /f "tokens=1,2,* delims=_ " %%A in ('"findstr /b /c:":extrasubmenu_" "%~f0""') do echo.  %%B  %%C
	
	call:printstatus
	
	set choice=
	echo.&set /p choice=Please make a selection or hit ENTER to return: ||GOTO:EOF
	echo.&call:extrasubmenu_%choice%
GOTO:menu_6

:menu_7 Dual-Boot Kindle Fire (You MUST already have TWRP + FFF installed)
	::This is APLHA...
	call:check_status
	
	call:header2
	
	for /f "tokens=1,2,* delims=_ " %%A in ('"findstr /b /c:":dualsubmenu_" "%~f0""') do echo.  %%B  %%C
	
	call:printstatus
	
	set choice=
	echo.&set /p choice=Please make a selection or hit ENTER to return: ||GOTO:EOF
	echo.&call:dualsubmenu_%choice%
GOTO:EOF

:menu_0    Recheck Device Status
	call:check_status
GOTO:EOF

::Submenus for Boot Modes

:bootsubmenu_1    Normal (4000)
	cls
	call:boot_normal
	pause
GOTO:EOF

:bootsubmenu_2   Fastboot (4002)
	cls
	call:boot_fastboot
	pause
GOTO:EOF

:bootsubmenu_3    Recovery (5001)
	cls
	call:boot_recovery
	pause
GOTO:EOF

:bootsubmenu_0    Recheck ADB/Fastboot Mode
	call:check_status
GOTO:EOF

::Submenus for Extras

:extrasubmenu_1    Install Google Apps / Go Launcher EX
	cls
	
	echo. ***********************************************
	echo. *               Apps Installer                *
	echo. ***********************************************
	echo.
	
	if "%adb%" == "Online" (
		::We need to check to make sure we are running root.
		IF EXIST apps\apps.zip (
			echo. apps.zip has been found.
			echo. Skipping download...
			echo.
		) else (
			::Looks like our apps.zip isn't downloaded, so lets get it.
			echo. apps.zip is missing.
			echo. So we will download it for you!
			echo.
			
			::Lets download our apps.
			call:download_apps		
		)

		::We need RW for this.
		call:mount_rw
		
		::Lets delete the shit apps we are hoping to replace with good apps.
		tools\adb shell su -c 'rm /system/app/Facebook.apk'

		::Lets install our default apps that are cooler.
		tools\adb install -r apps\data\GoogleServicesFramework.apk
		tools\adb install -r apps\data\com.gau.go.launcherex-1.apk
		tools\adb install -r apps\data\com.facebook.katana-1.apk
		tools\adb install -r apps\data\com.google.android.apps.googlevoice-1.apk
		tools\adb install -r apps\data\com.google.android.apps.plus-1.apk
		tools\adb install -r apps\data\SyncSettings.apk
		tools\adb install -r apps\data\Calendar.apk

		::Here is the stuff we need to put into /system/app.
		tools\adb push apps\system\vending.apk /data/local/vending.apk
		tools\adb push apps\system\GoogleCalendarSyncAdapter.apk /data/local/GoogleCalendarSyncAdapter.apk
		tools\adb push apps\system\GoogleContactsSyncAdapter.apk /data/local/GoogleContactsSyncAdapter.apk
		
		tools\adb shell su -c "cat /data/local/vending.apk > /system/app/vending.apk"
		tools\adb shell su -c "cat /data/local/GoogleCalendarSyncAdapter.apk > /system/app/GoogleCalendarSyncAdapter.apk"
		tools\adb shell su -c "cat /data/local/GoogleContactsSyncAdapter.apk > /system/app/GoogleContactsSyncAdapter.apk"
		
		tools\adb shell rm /data/local/vending.apk
		tools\adb shell rm /data/local/GoogleCalendarSyncAdapter.apk
		tools\adb shell rm /data/local/GoogleContactsSyncAdapter.apk

		::Fix our permissions of the new stuff
		tools\adb shell su -c 'chmod 644 /system/app/*'

		::Put the system back to read-only.
		call:mount_r

		tools\adb reboot
		echo.
		echo. ***********************************************
		echo. *                  All Done!                  *
		echo. ***********************************************
		echo.

		echo. That's all folks. Our apps have been installed.
		echo.

		::Pause to show our output
		pause
	) else (
		echo. Oops... something went wrong. 
		echo. We are unable to locate your Kindle Fire.
		echo. Make sure it is plugged in and powered on.
		echo.
		pause
	)
GOTO:EOF

:extrasubmenu_3    Lock Wallpaper
	call:check_status
	cls
	
	::We need to check to make sure we are running root.
	::Lock the wallpaper file from being touched.
	tools\adb shell su -c 'chmod 550 /data/data/com.android.settings/files/wallpaper'
	
	::Pause to show our output.
	
	echo. ***********************************************
	echo. *              Wallpaper Locked               *
	echo. ***********************************************
	echo.
	
	echo. The wallpaper has been Locked.
	echo.
	pause
GOTO:EOF

:extrasubmenu_4    Unlock Wallpaper
	call:check_status
	cls
	
	::We need to check to make sure we are running root.
	::Unlock the wallpaper file from being touched.
	tools\adb shell su -c 'chmod 770 /data/data/com.android.settings/files/wallpaper'
	
	::Pause to show our output.
	
	echo. ***********************************************
	echo. *             Wallpaper Unlocked              *
	echo. ***********************************************
	echo.
	
	echo. The wallpaper has been Unlocked.
	echo.
	pause.
GOTO:EOF

:extrasubmenu_5    Mount Read/Write
	call:mount_rw
	cls
	
	::We need to check to make sure we are running root.
	::Pause to show our output.
	
	echo. ***********************************************
	echo. *             Mounted Read/Write              *
	echo. ***********************************************
	echo.
	
	echo. The Kindle is now in Read/Write mode.
	echo.
	pause
GOTO:EOF

:extrasubmenu_6    Mount Read-Only
	call:mount_r
	cls
	
	::We need to check to make sure we are running root.
	::Pause to show our output.
	echo. ***********************************************
	echo. *             Mounted Read/Write              *
	echo. ***********************************************
	echo.
	echo. The Kindle is now in Read-Only mode.
	echo.
	pause
GOTO:EOF

:extrasubmenu_7  Download Amazon Kindle Fire 6.3.2 stock update.zip
	IF EXIST update\update.zip (
		cls
		echo. Update.zip has been found. Skipping...
		echo.
		pause
	) else (
		cls
		echo. Update.zip is missing.
		echo. So we will download it for you!
		echo.
		
		call:download_updatezip
		pause
	)
GOTO:EOF
:extrasubmenu_8  Download Amazon Kindle Fire 6.3.1 stock update.zip
	IF EXIST update\update_previous.zip (
		cls
		echo. Update_previous.zip has been found. Skipping...
		echo.
		pause
	) else (
		cls
		echo. Update_previous.zip is missing.
		echo. So we will download it for you!
		echo.
		
		call:download_updatezip_previous
		pause
	)
GOTO:EOF

:extrasubmenu_0    Recheck Device Status
	call:check_status
GOTO:EOF

:dualsubmenu_1    Install FireFireFire Extended and prep for Dual Boot
	::Let's run our install process...
	call:dualboot_first
	pause
GOTO:EOF

:dualsubmenu_2    Un-Dual Boot Kindle Fire
	::I don't know if this works yet...
	call:undualboot
	pause
GOTO:EOF

:dualsubmenu_3    Just install FireFireFire Extended 1.4.1
	call:install_fffe
	pause
GOTO:EOF

:dualsubmenu_0    Recheck Device Status
	call:checkstatus
GOTO:menu_6

::Functions

:header
	cls
	echo. *****************************************************************
	echo. *                   Kindle Fire Utility 0.9.9                   *
	echo. *****************************************************************
	echo. *            This is now being maintained by awidawad           *
	echo. *****************************************************************
	echo. *           Credit goes to Vashypooh for original work          *
	echo. *****************************************************************
	echo.
GOTO:EOF

:header2
	cls
	echo. ********************************************************************
	echo. *                   Kindle Fire Utility Dual Boot                  *
	echo. ********************************************************************
	echo. * For each of the steps have your device booted up in normal mode  *
	echo. ********************************************************************
	echo. * Also, please be patient as the utility is doing a lot of work... *
	echo. ********************************************************************
	echo.
GOTO:EOF

:printstatus
	echo.
	echo.
	echo. ADB Status: %adb%
	echo. Boot Status: %mode%
GOTO:EOF

:check_status
	::Determine ADB Status.
	set tmp=""
	for /f "tokens=1-4" %%a in ( 'tools\adb devices ^2^> nul' ) do ( set tmp="%%a %%b %%c %%d" )
	if /i %tmp% == %adbcomp% ( set adb=Offline)
	if /i not %tmp% == %adbcomp% ( set adb=Online)
	
	::Try and figure out our bootmode if possible.
	set mode=""
	if %mode% == "" ( for /f "tokens=3 delims= " %%a in ( 'tools\adb shell idme ? ^2^> nul ^| find /I "bootmode"' ) do ( set mode=%%a ) )
	if %mode% == "" ( set mode=Unknown)
	
	set tmp=""
GOTO:EOF

:boot_normal
	echo. ***********************************************
	echo. *           Activating Normal (4000)          *
	echo. ***********************************************
	echo.
	
	if "%adb%" == "Offline" (
		tools\fastboot -i 0x1949 oem idme bootmode 4000
		tools\fastboot -i 0x1949 reboot
		echo.
		echo. The kindle has been told to reboot in Normal Mode.
		echo.
	) else (
		::We need to check to make sure we are running root.
		::Switch ourselves into Recovery
		tools\adb wait-for-device
		tools\adb push files\nbmode /data/local/nbmode
		tools\adb shell chmod 755 /data/local/nbmode
		tools\adb shell /data/local/nbmode
		tools\adb reboot
		echo.
		echo. The kindle has been told to reboot in Normal Mode.
		echo.
	)
GOTO:EOF

:boot_fastboot
	echo. ***********************************************
	echo. *         Activating Fastboot (4002)          *
	echo. ***********************************************
	echo.
	
	if "%adb%" == "Online" (
		::Switch ourselves into fastboot
		tools\adb wait-for-device
		tools\adb push files\fbmode /data/local/fbmode
		tools\adb shell chmod 755 /data/local/fbmode
		tools\adb shell /data/local/fbmode
		tools\adb reboot
		echo.
		echo. The kindle has been told to reboot in Fastboot Mode.
		echo.
	) else (
		echo. Oops... something went wrong. 
		echo. We are unable to locate your Kindle Fire.
		echo. Make sure it is plugged in and powered on.
		echo.
	)
GOTO:EOF

:boot_recovery
	echo. ***********************************************
	echo. *          Activating Recovery (5001)         *
	echo. ***********************************************
	echo.
	
	if "%adb%" == "Online" (
		::We need to check to make sure we are running root.
		::Switch ourselves into Recovery
		tools\adb wait-for-device
		tools\adb push files\rcmode /data/local/rcmode
		tools\adb shell chmod 755 /data/local/rcmode
		tools\adb shell /data/local/rcmode
		tools\adb reboot
		echo.
		echo. The kindle has been told to reboot in Recovery Mode.
		echo.
	) else (
		tools\fastboot -i 0x1949 oem idme bootmode 5001
		tools\fastboot -i 0x1949 reboot
		echo.
		echo. The kindle has been told to reboot in Recovery Mode.
		echo.
	)
GOTO:EOF

:mount_rw
	::Remount /system/ and /cache/ with read/write.
	tools\adb shell su -c 'mount -o remount rw /system'
	tools\adb shell su -c 'mount -o remount rw /cache'
GOTO:EOF

:mount_r
	::Remount /system/ and /cache/ with read-only.
	tools\adb shell su -c 'mount -o remount ro /system '
	tools\adb shell su -c 'mount -o remount ro /cache'
GOTO:EOF

:download_updatezip
	cls

	::Determine what the latest url is.
	for /f "tokens=2 delims=|" %%a in ( 'tools\cat files/files.log ^| find /I "updateurl"' ) do ( set updateurl=%%a )
	
	if not EXIST update\ ( mkdir update )
	if not EXIST update_extract ( mkdir update_extract )
	
	::Download KF software and extract it
	tools\wget -O update\update.zip %updateurl%
	
		echo. Download successful.
		echo.
		tools\7za x update\update.zip -oupdate_extract\
GOTO:EOF

:download_updatezip_previous
	cls

	::Determine what the latest MD5 and url is.
	for /f "tokens=2 delims=|" %%a in ( 'tools\cat files/files.log ^| find /I "update1url"' ) do ( set update1url=%%a )
	for /f "tokens=2 delims=|" %%a in ( 'tools\cat files/files.log ^| find /I "update1md5"' ) do ( set update1md5=%%a )
	
	if not EXIST update\ ( mkdir update )
	if not EXIST update_extract ( mkdir update_extract )
	
	::Download KF software and extract it
	tools\wget -O update\update_previous.zip %update1url%
	
	for /f "tokens=1" %%a in ( 'tools\md5 update\update_previous.zip' ) do ( set md5check=%%a )
	
	if "%md5check%" == "%update1md5%" (
		echo. Download successful.
		echo.
		tools\7za x update\update_previous.zip -oupdate_extract\
	) else (
		echo.
		echo. ***********************************************
		echo. *                   WARNING                   *
		echo. ***********************************************
		echo.
		echo. Oops... something went wrong with the download.
		echo. The update_previous.zip downloaded is not correct.
		echo. Please try the download again.
		echo.
		pause
		goto:menuLOOP
	)
GOTO:EOF

:install_twrp
	::There's a bug here I just can't squash... TWRP "Fails" to download even tho it does. Removimg md5 is risky but it works... -awidawad
	cls
	echo. ***********************************************
	echo. *             Recovery Installer              *
	echo. ***********************************************
	echo.
	::Lets check our current device status
	call:check_status
	
	echo. ***********************************************
	echo. *                   WARNING                   *
	echo. ***********************************************
	echo.
	echo. Make sure to read each screen carefully!
	echo. Make sure to follow instructions given to you!
	echo.

	IF EXIST recovery\twrp.img (
		echo. twrp.img has been found.
		echo.
	) else (
		echo. twrp.img is missing.
		echo. So we will download it for you!
		echo.
		
		call:download_twrp
	)
	
	echo.
	echo. ***********************************************
	echo. *                    NOTICE                   *
	echo. ***********************************************
	echo.

	::Finally, install our TWRP.
	echo.
	echo. Installing TWRP...
	echo. If we get stuck here for awhile, power the kindle on and off a few times.
	echo. You should also check device manager for "kindle" If so, rerun the driver 
	echo. installer that came packaged with KFU.
	echo.
	
	call:boot_fastboot
	::There's a bug here I just can't squash... TWRP "Fails" to download even tho it does. Removimg md5 is risky but it works... -awidawad
		tools\fastboot -i 0x1949 flash recovery recovery\twrp.img
	echo. 

	::Display our read me.
	echo. ***********************************************
	echo. *                   READ ME                   *
	echo. ***********************************************
	echo.
	
	echo. If we get stuck here a long time, check the ADB drivers in windows.
	echo. Fastboot uses a different device than ADB, so make sure it is installed as an 
	echo. ADB device. If you see "kindle" in device manager, you need to install the 
	echo. drivers. You can also try running install_drivers.bat in the drivers folder.
	echo.
	echo. Do NOT unplug the kindle if we are stuck here, leave it plugged in and on.
	echo. Do NOT touch the kindle at all if we are stuck.

	echo. Setting Normal Bootmode.
	echo.
	echo. Please wait...
	echo.
	
	::Our TWRP reboot to normal trick. This should make the stuck in Triangle go away, permanently.
	::Also requires no user interaction anymore.
	tools\fastboot -i 0x1949 oem idme bootmode 4000
	tools\fastboot -i 0x1949 reboot	
	
	echo.
	echo. ***********************************************
	echo. *                  All Done!                  *
	echo. ***********************************************
	echo.

	echo. That's all folks. TWRP has been installed.
	echo. Please tap reboot on the kindle.
	echo.
	pause
GOTO:EOF

:download_twrp
	::There's a bug here I just can't squash... TWRP "Fails" to download even tho it does. Removimg md5 is risky but it works... -awidawad
	::Need to make sure our download location exists
	if not EXIST recovery\ ( mkdir recovery )
	
	::Determine what the latest MD5 and url is.
	for /f "tokens=2 delims=|" %%a in ( 'tools\cat files/files.log ^| find /I "twrpurl"' ) do ( set twrpurl=%%a )
	
	::Download KF software and extract it
	tools\wget -O recovery\twrp.img %twrpurl%
		echo. Download successful.
GOTO:EOF

:install_fff
	cls
	echo. ***********************************************
	echo. *           FireFireFire Installer            *
	echo. ***********************************************
	echo.
	::Lets check our current device status
	call:check_status
	
	IF EXIST recovery\fff.bin (
		echo. fff.bin has been found.
		echo.
	) else (
		echo. fff.bin is missing.
		echo. So we will download it for you!
		echo.
		
		call:download_fff
	)
	
	echo.
	echo. ***********************************************
	echo. *                    NOTICE                   *
	echo. ***********************************************
	echo.

	::Finally, install our TWRP.
	echo.
	echo. Installing FireFireFire...
	
	call:boot_fastboot
	
	for /f "tokens=2 delims=|" %%a in ( 'tools\cat files/files.log ^| find /I "fffmd5"' ) do ( set fffmd5=%%a )
	for /f "tokens=1" %%a in ( 'tools\md5 recovery\fff.bin' ) do ( set md5check=%%a )
	
	if "%md5check%" == "%fffmd5%" (
		tools\fastboot -i 0x1949 flash bootloader recovery\fff.bin
	) else (
		echo.
		echo. ***********************************************
		echo. *                   WARNING                   *
		echo. ***********************************************
		echo.
		echo. MD5 did not match. Aborting and deleting local content.
		del recovery\fff.bin
		rmdir recovery\
		tools\fastboot -i 0x1949 oem idme bootmode 4000
		tools\fastboot -i 0x1949 reboot
		pause
		exit
	)
	
	tools\fastboot -i 0x1949 oem idme bootmode 4000
	tools\fastboot -i 0x1949 reboot
	
	echo.
	echo. ***********************************************
	echo. *                  All Done!                  *
	echo. ***********************************************
	echo.

	echo. That's all folks. FireFireFire has been installed.
	echo.
	pause
GOTO:EOF

:download_fff
	::Need to make sure our download location exists
	if not EXIST recovery\ ( mkdir recovery )
	
	::Determine what the latest MD5 and url is.
	for /f "tokens=2 delims=|" %%a in ( 'tools\cat files/files.log ^| find /I "fffurl"' ) do ( set fffurl=%%a )
	for /f "tokens=2 delims=|" %%a in ( 'tools\cat files/files.log ^| find /I "fffmd5"' ) do ( set fffmd5=%%a )
	
	
	::Download KF software and extract it
	tools\wget -O recovery\fff.bin %fffurl%
	
	for /f "tokens=1" %%a in ( 'tools\md5 recovery\fff.bin' ) do ( set md5check=%%a )
	
	if "%md5check%" == "%fffmd5%" (
		echo. Download successful.
	) else (
		echo.
		echo. ***********************************************
		echo. *                   WARNING                   *
		echo. ***********************************************
		echo.
		echo. Oops... something went wrong with the download.
		echo. The recovery downloaded is not correct.
		echo. Please try the download again.
		echo. 
		pause
		del recovery\fff.bin
		rmdir recovery\
		exit
	)
GOTO:EOF

:download_apps
	::Need to make sure our download location exists
	if not EXIST apps\ ( mkdir apps )
	
	::Determine what the latest MD5 and url is.
	for /f "tokens=2 delims=|" %%a in ( 'tools\cat files/files.log ^| find /I "appsurl"' ) do ( set appsurl=%%a )
	for /f "tokens=2 delims=|" %%a in ( 'tools\cat files/files.log ^| find /I "appsmd5"' ) do ( set appsmd5=%%a )
	
	::Download KF software and extract it
	tools\wget -O apps\apps.zip %appsurl%
	
	for /f "tokens=1" %%a in ( 'tools\md5 apps\apps.zip' ) do ( set md5check=%%a )
	
	if "%md5check%" == "%appsmd5%" (
		echo. Download successful.
		echo.
		tools\7za x apps\apps.zip -oapps\
	) else (
		echo.
		echo. ***********************************************
		echo. *                   WARNING                   *
		echo. ***********************************************
		echo.
		echo. Oops... something went wrong with the download.
		echo. The Apps downloaded is not correct.
		echo. Please try the download again.
		echo. 
		del apps\apps.zip
		rmdir apps\
		pause
		goto:menuLOOP
	)
GOTO:EOF

:rootkindle
	echo. ***********************************************
	echo. *          Installing Permanent Root          *
	echo. ***********************************************
	echo.
	
	call:boot_fastboot
	
	IF EXIST recovery\twrp.img (
		echo. twrp.img has been found.
		echo.
	) else (
		echo. twrp.img is missing.
		echo. So we will download it for you!
		echo.
		
		call:download_twrp
	)
	
	IF EXIST recovery\fff.bin (
		echo. fff.bin has been found.
		echo.
	) else (
		echo. fff.bin is missing.
		echo. So we will download it for you!
		echo.
		
		call:download_fff
	)
	
	echo.
	echo. ***********************************************
	echo. *                    NOTICE                   *
	echo. ***********************************************
	echo.
	
	for /f "tokens=2 delims=|" %%a in ( 'tools\cat files/files.log ^| find /I "twrpmd5"' ) do ( set twrpmd5=%%a )
	for /f "tokens=2 delims=|" %%a in ( 'tools\cat files/files.log ^| find /I "fffmd5"' ) do ( set fffmd5=%%a )
	
	echo.
	echo. Fastboot uses a different device than ADB.
	echo. You should check device manager for "Kindle" or "Amazon"
	echo.  
	echo. If you see it, rerun the driver installer that came packaged with KFU.
	echo.
	
	echo. Installing FFF...
		tools\fastboot -i 0x1949 flash bootloader recovery\fff.bin
	echo.
	echo. Installing TWRP...
	echo.
		tools\fastboot -i 0x1949 flash recovery recovery\twrp.img
	
	::Display our read me.
	echo. 
	echo. Setting Recovery Bootmode.
	echo.
	tools\fastboot -i 0x1949 oem idme bootmode 5001
	tools\fastboot -i 0x1949 reboot	
	echo.
	echo. Please wait...
	echo.
	
	::Our TWRP reboot to normal trick.
	::Also requires no user interaction anymore.
	:rootloop
	tools\adb shell "idme bootmode 4000" 2> nul
	if not %errorlevel% == 0 ( goto rootloop )
	
	tools\adb shell mount system
	tools\adb push files\su /system/xbin/su
	tools\adb shell chown 0.0 /system/xbin/su
	tools\adb shell chmod 06755 /system/xbin/su
	::Disable root checker.
	echo.
	echo. Attempt to remove root checker.
	echo.
	tools\adb shell mv /system/bin/check_rooted /system/bin/check_rooted.bak
	:::Reboot the kindle.
	tools\adb reboot
	echo.
	echo. Please wait...
	echo.

	::Wait for Android to finish booting, and install Superuser.apk.
	tools\adb wait-for-device
	::THIS CAUSED A BUG HERE WHEN IT WAS 20 IT NEVER INSTALLED SUPERUSER... SORRY! Bug Fixed in v0.9.9
	::60 sec should give us more than enough time
	echo. This may take up to 1 minute...
	tools\sleep 60
	echo. Installing Superuser.apk
	tools\adb install -r files\Superuser.apk 2> nul
	
	echo.
	echo. ***********************************************
	echo. *               Root Installed                *
	echo. ***********************************************
	echo.
	echo. Permanent root has been installed.
	echo. With great power, comes great responsibility.
	echo.
	echo. Please be careful with how you use root.
	echo.
GOTO:EOF

::Dualboot function new and beta... -awidawad
:dualboot_first
	::There was a bug here now this function is almost useless...
	echo. ***********************************************
	echo. *    Connect your device in normal mode...    *
	echo. ***********************************************
	pause
	echo. ***********************************************
	echo. *           Prepping for Dual-Boot...         *
	echo. ***********************************************
	call:install_fffe
GOTO:EOF

:install_fffe
	echo. Installing FireFireFire...
	echo. ******************************************************
	echo. *  Please be patient as this will take some time...  *
	echo. ******************************************************
	echo.
	call:download_fffe
	::Flash new bootloader...
	call:boot_fastboot
	echo. Writing new bootloader...
	tools\fastboot flash bootloader recovery\fffe.bin
	tools\fastboot -i 0x1949 oem idme bootmode 4000
	tools\fastboot reboot
	pause
	echo.    ****************************************
	echo.    * Please wait for device to boot up... *
	echo.    ****************************************
	pause
	::And again...
	call:boot_fastboot
	echo. Re-Partitioning for Dual-Boot...
	::Now to finish install...
	::Next let's re-partition our lovely Kindle...
	tools\fastboot oem dualformat
	::That's it! Plain and simple!
	tools\fastboot -i 0x1949 oem idme bootmode 4000
	tools\fastboot reboot
	echo. Complete!
	pause
GOTO:EOF

:download_fffe
	::Need to make sure our download location exists
	if not EXIST recovery\ ( mkdir recovery )
	
	::Determine what the latest url is.
	for /f "tokens=2 delims=|" %%a in ( 'tools\cat files/files.log ^| find /I "fffeurl"' ) do ( set fffeurl=%%a )
	
	::Download KF software and extract it
	tools\wget -O recovery\fffe.bin %fffeurl%
	::Removed md5 checksum stuff till I work out md5 bug... If bad download u-boot will reject corrupt bootloader as safeguard.
		echo. Download successful.
GOTO:EOF

:undualboot
	echo. ***********************************************
	echo. *    Plug in your device in normal mode...    *
	echo. ***********************************************
	pause
	call:boot_fastboot
	::Un-Dual Boot process is simple...
	tools\fastboot oem format
	pause
	tools\fastboot reboot
	call:install_fff
GOTO:EOF

:push_wipe
	call:boot_recovery
	echo. Press when booted into recovery...
	pause
	tools\adb push files\altrom-format-all.zip /sdcard
	tools\adb push files\altrom-factory-reset.zip /sdcard
GOTO:EOF

::Yes to all you curious code viewers, this COTR install script also has an md5checksum bug. This will NOT effect the installation at all, what so ever, so don't tell me my script don't work like before you did ;P
:install_cotr
	cls
	echo. ***********************************************
	echo. *           COTR Recovery Installer           *
	echo. ***********************************************
	echo.
	::Lets check our current device status
	call:check_status
	
	echo. ***********************************************
	echo. *                   WARNING                   *
	echo. ***********************************************
	echo.
	echo. Make sure to read each screen carefully!
	echo. Make sure to follow instructions given to you!
	echo.

	IF EXIST recovery\cotr.img (
		echo. cotr.img has been found.
		echo.
	) else (
		echo. cotr.img is missing.
		echo. So we will download it for you!
		echo.
		
		call:download_cotr
	)
	
	echo.
	echo. ***********************************************
	echo. *                    NOTICE                   *
	echo. ***********************************************
	echo.

	::Finally, install our COTR.
	echo.
	echo. Installing COTR...
	echo. If we get stuck here for awhile, power the kindle on and off a few times.
	echo. You should also check device manager for "kindle" If so, rerun the driver 
	echo. installer that came packaged with KFU.
	echo.
	
	call:boot_fastboot
		tools\fastboot -i 0x1949 flash recovery recovery\cotr.img
	echo. 

	::Display our read me.
	echo. ***********************************************
	echo. *                   READ ME                   *
	echo. ***********************************************
	echo.
	
	echo. If we get stuck here a long time, check the ADB drivers in windows.
	echo. Fastboot uses a different device than ADB, so make sure it is installed as an 
	echo. ADB device. If you see "kindle" in device manager, you need to install the 
	echo. drivers. You can also try running install_drivers.bat in the drivers folder.
	echo.
	echo. Do NOT unplug the kindle if we are stuck here, leave it plugged in and on.
	echo. Do NOT touch the kindle at all if we are stuck.

	echo. Setting Normal Bootmode.
	echo.
	echo. Please wait...
	echo.
	
	::Our reboot to normal trick. This should make the stuck in Triangle go away, permanently.
	::Also requires no user interaction anymore.
	tools\fastboot -i 0x1949 oem idme bootmode 4000
	tools\fastboot -i 0x1949 reboot	
	
	echo.
	echo. ***********************************************
	echo. *                  All Done!                  *
	echo. ***********************************************
	echo.

	echo. That's all folks. COTR has been installed.
	echo. Please tap reboot on the kindle.
	echo.
	pause
GOTO:EOF

:download_cotr
	::Need to make sure our download location exists
	if not EXIST recovery\ ( mkdir recovery )
	
	::Determine what the latest MD5 and url is.
	for /f "tokens=2 delims=|" %%a in ( 'tools\cat files/files.log ^| find /I "cotrurl"' ) do ( set cotrurl=%%a )
	
	::Download KF software and extract it
	tools\wget -O recovery\cotr.img %cotrurl%
		echo. Download successful.
GOTO:EOF